unit IWCompEdit32;

{PUBDIST}

interface

uses
  {$IFDEF VSNET}
  System.ComponentModel, System.Drawing,
  {$ELSE}
  {$IFDEF Linux}QControls, {$ELSE}Controls, {$ENDIF}
  {$ENDIF}
  {$IFDEF Linux}QGraphics, {$ELSE}Graphics, {$ENDIF}
  Classes,
  IWControl32, IWHTMLTag, IWRenderContext, IWBaseInterfaces;

type
  TIWCustomEdit32 = class(TIWCustomControl32, IIWInputControl)
  protected
    FPasswordPrompt: Boolean;
    FTagType: string;
    FMaxLength : integer;

    procedure SetValue(const AValue: string); virtual;
    procedure SetPasswordPrompt(const AValue: Boolean);

    procedure InitControl; override;

    property MaxLength : integer read FMaxLength write FMaxLength;
  public
    function RenderHTML(AContext: TIWBaseHTMLComponentContext): TIWHTMLTag; override;
    property PasswordPrompt: Boolean read FPasswordPrompt write SetPasswordPrompt;
  end;

  {$IFDEF VSNET}
  {$R icons\Atozed.Intraweb.IWCompEdit32.TIWEdit32.bmp}
  TIWEdit32 = class;
  [ToolboxItem(true), ToolboxBitmap(typeof(TIWEdit32), 'TIWEdit32.bmp')]
  {$ENDIF}
  TIWEdit32 = class(TIWCustomEdit32)
  public
    procedure Clear;
  published
    property PasswordPrompt;
    property MaxLength;
    property Text;
    {$IFDEF CLR}
    property WebFont;
    {$ELSE}
    property Font;
    {$ENDIF}
  end;

implementation

uses
  SysUtils,
  SWSystem, IWBaseControl;

{ TIWCustomEdit32 }

procedure TIWCustomEdit32.InitControl;
begin
  inherited;
  Height := 21;
  Width := 121;
  FTagType := 'TEXT';
end;

function TIWCustomEdit32.RenderHTML(AContext: TIWBaseHTMLComponentContext): TIWHTMLTag; 
begin
  Result := nil;
  Result := TIWHTMLTag.CreateTag('INPUT');
  try
    Result.AddStringParam('TYPE', FTagType);
    Result.AddStringParam('NAME', HTMLName);
    if MaxLength > 0 then
    begin
      Result.AddIntegerParam('MAXLENGTH', MaxLength);
    end;
    Result.AddIntegerParam('SIZE', Width div 7);
    Result.AddStringParam('VALUE', TextToHTML(Text));
    // TODO: Does 3.2 support readonly?
  //  Result.Add(iif(ReadOnly, 'READONLY'));
  except
    FreeAndNil(Result);
    raise;
  end;
end;

procedure TIWCustomEdit32.SetPasswordPrompt(const AValue: Boolean);
begin
  FTagType := IIF(AValue, 'PASSWORD', 'TEXT');
  FPasswordPrompt := AValue;
end;

procedure TIWCustomEdit32.SetValue(const AValue: string);
begin
  Text := AValue;
  Invalidate;
end;

{ TIWEdit32 }

procedure TIWEdit32.Clear;
begin
  Text := '';
end;

end.
