unit IWCompLabel32;
{PUBDIST}

interface

uses
  {$IFDEF VSNET}
System.ComponentModel, System.Drawing,
  {$ELSE}
  {$IFDEF Linux}QControls, {$ELSE}Controls, {$ENDIF}
  {$ENDIF}
  {$IFDEF Linux}QGraphics, {$ELSE}Graphics, {$ENDIF}
  Classes,
  IWControl32, IWHTMLTag, IWRenderContext, IWMarkupLanguageTag;

type
  TIWCustomLabel32 = class(TIWCustomControl32)
  protected
    FRawText: Boolean;
    //
    procedure SetAutoSize(Value: Boolean); override;
    procedure InitControl; override;
  public
    function RenderHTML(AContext: TIWBaseHTMLComponentContext): TIWHTMLTag; override;

    property RawText: Boolean read FRawText write FRawText default FALSE;
    {$IFNDEF CLR}
    property WebFont;
    {$ENDIF}
  published
    {$IFDEF CLR}
    property WebFont;
    {$ELSE}
    property Font;
    {$ENDIF}
  end;

  {$IFDEF VSNET}
  {$R icons\Atozed.Intraweb.IWCompLabel32.TIWLabel32.bmp}
  TIWLabel32 = class;
  [ToolboxItem(true), ToolboxBitmap(typeof(TIWLabel32), 'TIWLabel32.bmp')]
  {$ENDIF}
  TIWLabel32 = class(TIWCustomLabel32)
  published
    property Caption;
    property RawText;
  end;

implementation

uses
  SysUtils;

function TIWCustomLabel32.RenderHTML(AContext: TIWBaseHTMLComponentContext): TIWHTMLTag;
begin
  //Fix this to allow CreateText
  Result := TIWHTMLTag.Create(TIWMarkupLanguageElement(nil));
  try
     if not RawText then
     begin
        Result.Contents.AddTagAsObject(WebFont.FontToStringTag32(TextToHTML(Caption)));
     end
     else
     begin
        Result.Contents.AddText(Caption);
     end;
  except
     FreeAndNil(Result);
     raise;
  end;
end;

procedure TIWCustomLabel32.InitControl;
begin
  inherited;
  Height := 21;
  Width := 121;
  AutoSize := true;
  FRawText := FALSE;
end;

procedure TIWCustomLabel32.SetAutoSize(Value: Boolean);
begin
  inherited SetAutoSize(Value);
  Invalidate;
end;

end.

